/******************************************************************************
ݒΒ쒥Ò˒뒴ؒ
******************************************************************************/

#include <stdio.h>
#include <string.h>		/* strcpy, strlen */
#include <limits.h>		/* INT_MAX */
#include "tx.h"

char usr[MAXLIN][MAXCOL + 1];			/* 撡Βϒᒤ */

void evaluate(char *tt, char *uu);		/* ΒՒ뒤Β钤ϒƒВ쒤ʒ */

void start_prompt(void);				/* Βؒ lesson2.c ˒ */
void user_input(char* u);
void end_prompt(void);


/******************************************************************************
ڒؒ̾	Lesson_init
ڒǽ	ʸޒΒՒ뒤ɒߒ
ڒ	ʒ
ڒᒤ͒	ʒ
******************************************************************************/
void Lesson_init(void) {
	int i;
	FILE* in;

	if ((in = fopen(figfname, "r")) == NULL) {
		ending("ޒΒՒ뒡%sגגǒޒ.", figfname);
	}

		/* ɒߒߒ֒꒤ƒ撡ےʒ쒹璤 */
		/* ǒᒥÒВȒ蒤							*/

	for (i = 0; i < MAXFIGURENUM; i++) {
		if (feof(in)) {
			goto next;							/* ǒ咤ޒǒɒᒤ */
		}
		figptr[i] = Figure_read(in);
	}
	ending("ޒΒՒ뒡%sגΒޒΒ¿ޒ.", figfname);

next:

	fclose(in);

	if ((in = fopen(txtfname, "r")) == NULL) {
		ending("ʸΒՒ뒡%sגגǒޒ.", txtfname);
	}

		/* ɒߒߒ֒꒤ƒ撡ےʒ쒹璤 */
		/* ǒᒥÒВȒ蒤							*/

	for (i = 1; i < MAXLESSONNUM; i++) {
		if (feof(in)) {
			goto next2;							/* ǒ咤ޒǒɒᒤ */
		}
		txtptr[i] = Text_read(in, i);
	}
	ending("ʸΒՒ뒡%sגΒݒΒ¿ޒ.", txtfname);

next2:

	lastlessonnum = i-1;
	fclose(in);
} /* Lesson_init */


/******************************************************************************
ڒؒ̾	Lesson_show
ڒǽ	쒥Ò򒸫뒡
ڒ	ʒ
ڒᒤ͒	ʒ
******************************************************************************/
void Lesson_show(void) {
	int i, j;
	Text* t;

	if (lessonnum > lastlessonnum) {
		ending("撤ΒݒΒ֒撤ےǒ.", NULL);
	}

	t = txtptr[lessonnum];

	strcpy(lessonname, t->textname);
	xgotoxy(1, 3);							/* 쒥Ò̾ɽϒ̒ */
	xprintf("%-22s", t->textname);			/* 쒥Ò̾ɽ */

#ifdef PC98
	showmenu("return    ESC λ    ʒ    ᒤ");
#else /* not PC98 */
	showmenu("Enter    ESC λ    ʒ    ᒤ");
#endif /* not PC98 */

	if (t->figurename[0] != '\0') {			/* ޒɽ */
		Figure_show(t->figurename);
	}

	j = line;
	for (i = 0; i < LINES - 5 && t->string[i] != NULL; i++) {
		xgotoxy(j, 1); j++;					/* 뒰ܒư */
		xprintf("%s", t->string[i]);		/* ϒΒʸɽ */
		xclr2end();							/* Ԓޒǒ꒥ */
	}

	line = j;
	for (i = 0; i < MAXLIN && t->txt[i] != NULL; i++) {
		xgotoxy(j, 1);						/* 뒰ܒư */
		xcolor4text1();						/* ʸɽ */
		xprintf("%s", t->txt[i]);			/* ʸɽ */
		xcolornormal();						/* ǒՒ뒥Ȓ */
		xclr2end();							/* Ԓޒǒ꒥ */
		j++;
		xgotoxy(j, 1);						/* ʸΒΒԒϒÒ */
		xclr2end();
		j++;
	}

	for (i = j; i <= LINES - 3; i++) {		/* Ē꒤ΒʬΒÒ */
		xgotoxy(i, 1);
		xclr2end();							/* Ԓޒǒ꒥ */
	}
											/* ܒɸΒɽ */
	if (t->txt[0] != NULL) {
		char tmp[128];
		Myfloat tmps;

		errorlim = t->errorlim;
		Myfloat_sprintf(str_errorlim, errorlim);

		xgotoxy(LINES - 1, 1);
		xprintf("ԒܒɸՒ钡Ψ %3s %% ̤", str_errorlim);
		xclr2end();

		for (i = 1; i < lessonnum; i++) {
			if (txtptr[i]->isclear == 'x') {
				xgotoxy(LINES - 1, 36);
				xcolor4no();
				xprintf("Βݒʒ˒̤璳ʒΒݒ꒤ޒ.");
				xclr2end();
			}
		}

		xgotoxy(LINES - 1, 71);
		if (t->isclear == 'x') {
			xcolor4no();
			xprintf("̤璳");
		} else if (t->isclear == 'o') {
			xcolor4ok();
			xprintf("璳ʒ");
		}
		xcolornormal();
		xclr2end();

		timelim = t->timelim;
		Myfloat_sprintf(str_timelim, timelim);

		xgotoxy(LINES - 0, 1);
		xprintf("          Ò/(ǒ-%dx钡) %5s ̤",
					penalty, str_timelim);
		Myfloat_init(&tmps, 12, 1, 1);
		Myfloat_sprintf(tmp, Myfloat_div(tmps, timelim, 1));
		xprintf("  (i.e. 1ʬ %s ɒʒ)", tmp);
		xclr2end();
	} else {
		copyright();
	}
} /* Lesson_show */


/******************************************************************************
ڒؒ̾	Lesson_next
ڒǽ	Βݒؒʒ
ڒ	ʒ
ڒᒤ͒	ʒ
******************************************************************************/
void Lesson_next(void) {
	if (lessonnum < lastlessonnum) {
		lessonnum++;
	} else {
		bell();
	}
} /* Lesson_next */


/******************************************************************************
ڒؒ̾	Lesson_prev
ڒǽ	Βݒؒᒤ뒡
ڒ	ʒ
ڒᒤ͒	ʒ
******************************************************************************/
void Lesson_prev(void) {
	if (lessonnum != 1) {
		lessonnum--;
	} else {
		bell();
	}
} /* Lesson_prev */


/******************************************************************************
ڒؒ̾	Lesson_practice
ڒǽ	򒤵뒡
ڒ	ʒ
ڒᒤ͒	ʒ
******************************************************************************/
void Lesson_practice(void) {
	int i;
	unsigned long tmp_time;
	Text* tptr = txtptr[lessonnum];

	strokes = 0;					 /* Ȓ풡Β */
	for (i = 0; i < MAXLIN && tptr->txt[i]; i++) {
		strokes += strlen(tptr->txt[i]);
	}

	if (strokes == 0) {				/* ʸΒʒݒ蒤Ȓ */
		bell();						/* ْ뒤Ē钤ƒ֒ */
		return;
	}

	errors = 0;							/* 钡򒥯꒥ */
	your_strokes = 0;					/* 撡Ȓ풡򒥯꒥ */
	errorlim = tptr->errorlim;			/* ܒɸ钡Ψ򒥻Ò */
	timelim = tptr->timelim;			/* ܒɸ򒥻Ò */

xgotoxy(1, 1);					/* ϒ̒֒ؒ뒤ܒư */
	start_prompt();						/* ϒג풥ג */

	starttime = time(NULL);				/* ϒ򒵭Ͽ */

#ifndef LINUX
	xgotoxy(line, 1);			/* ϒ̒֒ؒ뒤ܒư */
#endif

	for (i = 0; i < MAXLIN && tptr->txt[i]; i++) {
#ifdef LINUX
	    xgotoxy(line + 2 * i, 1);		/* ϒ̒֒ؒ뒤ܒư */
#endif
		user_input(usr[i]);				/* 撡 */
		your_strokes += strlen(usr[i]);	/* ǒ򒥫 */
		xgotoxy(line + 2 * i, 1);
		xcolor4text0();					/* ߒʸΒ˒ */
		xprintf(tptr->txt[i]);			/* ߒʸΒ */
		xcolornormal();					/* ǒՒ뒥Ȓ˒ᒤ */
	}

	endtime = time(NULL);					/* λ򒵭Ͽ */

	tmp_time  = struct_tm2sec(gmtime(&endtime));
	tmp_time -= struct_tm2sec(gmtime(&starttime));

											/* ג֒򒵭Ͽ */
	if (tmp_time <= INT_MAX) {
		seconds = (int) (tmp_time);
	} else {
		seconds = INT_MAX;
	}

	for (i = 0; i < MAXLIN && tptr->txt[i]; i++) {		/* ʸƒɽ */
		xgotoxy(line + 2 * i, 1);
		xcolor4text1();					/* ʸɽђΒ˒ђ */
		xprintf(tptr->txt[i]);			/* ⒤ْʸɽ */
		xcolornormal();					/* Βޒ뒤Β˒ᒤ */
		xgotoxy(line + 2 * i + 1, 1);
		evaluate(tptr->txt[i], usr[i]);	/* Β뒲̒Β̒ɽ */
		xclr2end();						/* Ԓޒǒ */
	}

	if (Score_write() == OK) {			/* 뒲̒Β̒ɽǒ񒤭 */
		tptr->isclear = 'o';
	}

	end_prompt();						/* 쒤ĒΒΒλג풥ג */

	return;
} /* Lesson_practice */



enum VECS { END = 0x00, \
			COR = 0x01, WRG = 0x02, INS = 0x04, DRP = 0x08, XCH = 0x10 };

/******************************************************************************
ڒؒ̾	evaluate()
ڒǽ	ĒΒʸ撳Ӓ뒲̒ err[][] ˒ʒǼ撳Ӓ뒲̒Β̒Вϒ
ڒ	ĒΒʸ󒡣
ڒᒤ͒	ʒ
ڒ풡Ւ	֒ĒΒʸ撳ӒגȒǽϒ˒ƒђǒ뒤ϒޒ
			ƒђΒ뒡ǒϒʒΒǒ풰Ւ蒡:-)
******************************************************************************/
void evaluate(char *t, char *u) {
	int i, j;
	int tlen, ulen;

	static char err[MAXCOL+1][MAXCOL+1];
	static char cmp[MAXCOL+1][MAXCOL+1];
	static char cor[MAXCOL+1][MAXCOL+1];
	static char vec[MAXCOL+1][MAXCOL+1];

	tlen = strlen(t);
	ulen = strlen(u);

	err[tlen][ulen] = 0;				/* Ȓ钴ɒΒ */
	cmp[tlen][ulen] = 0;
	cor[tlen][ulen] = NO;
	vec[tlen][ulen] = END;

	for (i = 0; i < tlen; i++) {		/* Ȓ钴ɒΒ */
		err[i][ulen] = tlen - i;
		cmp[i][ulen] = 0;
		cor[i][ulen] = NO;
		vec[i][ulen] = DRP;
	}
	for (j = 0; j < ulen; j++) {		/* Ȓ钴ɒΒ */
		err[tlen][j] = ulen - j;
		cmp[tlen][j] = 0;
		cor[tlen][j] = NO;
		vec[tlen][j] = INS;
	}

	for (i = tlen - 1; i >= 0; i--) {
		for (j = ulen - 1; j >= 0; j--) {
			int tmperr, tmpcmp;
			if (t[i] == u[j]) {
				tmperr = err[i+1][j+1];			/*  */
				if (cor[i+1][j+1] == OK) {
					tmpcmp = cmp[i+1][j+1];
				} else {
					tmpcmp = cmp[i+1][j+1]+1;
				}
				cor[i][j] = OK;
				vec[i][j] = COR;
			} else {
				tmperr = err[i+1][j+1]+1;		/*  */
				tmpcmp = cmp[i+1][j+1];
				cor[i][j] = NO;
				vec[i][j] = WRG;
			}
			if (t[i] == u[j+1] && t[i+1] == u[j]) {	/* ž */
				if (tmperr > err[i+2][j+2]+1 ||
					tmperr == err[i+2][j+2]+1 && tmpcmp > cmp[i+2][j+2]) {
						tmperr = err[i+2][j+2]+1;
						tmpcmp = cmp[i+2][j+2];
						cor[i][j] = NO;
						vec[i][j] = XCH;
					/* err[i+2][j+2] ϒ֒ʒϒ˒ ͒蒡 */
				}
			}
			if (tmperr > err[i][j+1]+1 ||			/* ޒ */
				tmperr == err[i][j+1]+1 && tmpcmp > cmp[i][j+1]) {
					tmperr = err[i][j+1]+1;
					tmpcmp = cmp[i][j+1];
					cor[i][j] = NO;
					vec[i][j] = INS;
			}
			if (tmperr > err[i+1][j]+1 ||			/* æ */
				tmperr == err[i+1][j]+1 && tmpcmp > cmp[i+1][j]) {
					tmperr = err[i+1][j]+1;
					tmpcmp = cmp[i+1][j];
					cor[i][j] = NO;
					vec[i][j] = DRP;
			}
			err[i][j] = tmperr;
			cmp[i][j] = tmpcmp;
		}
	}

	errors += err[0][0];

	i = j = 0;
	while (vec[i][j] != END) {
		if (vec[i][j] & COR) {				/*  */
			putchar(u[j]); i++, j++;
		} else if (vec[i][j] & WRG) {		/*  */
			xcolor4wrong();
			printf("%c", u[j]); i++, j++;
			xcolornormal();
		} else if (vec[i][j] & INS) {		/* ޒ */
			xcolor4inserted();
			printf("%c", u[j]); j++;
			xcolornormal();
		} else if (vec[i][j] & DRP) {		/* æ */
			xcolor4dropped();
			printf("%c", CHAR4DROPPED); i++;
			xcolornormal();
		} else if (vec[i][j] & XCH) {		/* ž */
			xcolor4xposed();
			printf("%c%c", u[j], u[j+1]); i+=2, j+=2;
			xcolornormal();
		}
	}
} /* evaluate */
